<ng-container *ngIf="{
          ghostElements: ghostElements$ | async,
          screenSize: screenSize$ | async,
          teamPage: dataPage$ | async,
          categories: categories$ | async,
          participants: participants$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.team.list.seo.title' | translate }}
      </h1>
      <p>
        {{ 'admin.team.list.seo.description' | translate }}
      </p>

      <form [formGroup]="formGroup">
        <mat-form-field>
          <mat-label>
            {{ 'admin.team.list.filter.category' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().category"
                                 (resetClick)="categoryChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.category"
                            [control]="formGroup.controls.category">
            <mat-select formControlName="category" (selectionChange)="categoryChange($event.value)">
              <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                          [value]="category.slug">
                {{ category.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.team.list.filter.participant' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().participant"
                                 (resetClick)="participantChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.participant"
                            [control]="formGroup.controls.participant">
            <mat-select formControlName="participant" (selectionChange)="participantChange($event.value)">
              <mat-option *ngFor="let participant of vm.participants?.items; trackBy: trackBySlug"
                          [value]="participant.slug" class="team">
                <figure *ngIf="'common.team.defaultPicture.url' | translate">
                  <img class="lazy-load"
                       [lazyLoad]="participant.logoUrl || ('common.team.defaultPicture.url' | translate)"
                       [errorImage]="'common.team.defaultPicture.url' | translate"
                       [alt]="participant.name" />
                  <figcaption>
                    <span>
                      {{ participant | teamName:vm.screenSize }}
                    </span>
                    <strong *ngIf="!formGroup.value.category">
                      {{ participant.categoryName }}
                    </strong>
                  </figcaption>
                </figure>
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
      </form>

      <section>
        <div class="table-wrapper">
          <table mat-table [dataSource]="loading.list ? vm.ghostElements : vm.teamPage?.items"
                 [trackBy]="trackBySlug"
                 matSort matSortDisableClear
                 (matSortChange)="sort($event)"
                 [matSortActive]="vm.teamPage?.sort?.field || 'participantName'"
                 [matSortDirection]="vm.teamPage?.sort?.direction || 'asc'">

            <ng-container matColumnDef="logo">
              <th mat-header-cell *matHeaderCellDef
                  class="logo">
                {{ 'admin.team.list.field.logo' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                <figure>
                  <img class="lazy-load"
                       *ngIf="'common.team.defaultPicture.url' | translate"
                       [lazyLoad]="element.logoUrl || ('common.team.defaultPicture.url' | translate)"
                       [errorImage]="'common.team.defaultPicture.url' | translate"
                       [alt]="element.name"/>
                </figure>
              </td>
            </ng-container>

            <ng-container matColumnDef="participantName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.team.list.field.name' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.name }}
              </td>
            </ng-container>

            <ng-container matColumnDef="participantShortName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.team.list.field.shortName' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.shortName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="index">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.team.list.field.index' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.index }}
              </td>
            </ng-container>

            <ng-container matColumnDef="categoryName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.team.list.field.category' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.categoryName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="action">
              <th mat-header-cell *matHeaderCellDef></th>
              <td mat-cell *matCellDef="let element"
                  class="actions">
                <a mat-icon-button
                   [routerLink]="[element.slug, 'update']"
                   [attr.aria-label]="'admin.common.action.update' | translate"
                   [matTooltip]="'admin.common.action.update' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    edit
                  </mat-icon>
                </a>
                <a mat-icon-button
                   [routerLink]="[element.slug, 'duplicate']"
                   [attr.aria-label]="'admin.common.action.duplicate' | translate"
                   [matTooltip]="'admin.common.action.duplicate' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    filter_none
                  </mat-icon>
                </a>
                <button mat-icon-button
                        (click)="delete(element)"
                        [attr.aria-label]="'admin.common.action.delete' | translate"
                        [matTooltip]="'admin.common.action.delete' | translate"
                        matTooltipPosition="left">
                  <mat-icon>
                    delete
                  </mat-icon>
                </button>
              </td>
            </ng-container>

            <ng-container *ngFor="let ghostColumn of ghostColumns">
              <ng-container [matColumnDef]="ghostColumn">
                <td mat-cell *matCellDef class="ghost"><div></div></td>
              </ng-container>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="columns; sticky: true"></tr>
            <ng-container *ngIf="loading.list then ghost; else data"></ng-container>
            <ng-template #data>
              <tr mat-row *matRowDef="let row; columns: columns;"></tr>
            </ng-template>
            <ng-template #ghost>
              <tr mat-row *matRowDef="let row; columns: ghostColumns;"></tr>
            </ng-template>
          </table>
        </div>
        <mat-paginator [length]="vm.teamPage?.count"
                       [pageIndex]="vm.teamPage?.page"
                       [pageSize]="vm.teamPage?.size"
                       [pageSizeOptions]="pageSizes"
                       (page)="goToPage($event)">
        </mat-paginator>
      </section>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-flat-button color="primary"
         [routerLink]="['create']"
         [queryParams]="{ category: formGroup.value.category, participant: formGroup.value.participant }">
        <mat-icon>
          add
        </mat-icon>
        {{ 'admin.common.action.create' | translate }}
      </a>
    </ng-container>
  </app-page-form>
</ng-container>
